<template>
  <div id="deviceList">
    <el-row class="right">
      <span style="float:left;">当前选择的设备族:{{ category.name }}</span>
      <el-select v-model="showType" @change="initTable" style="width:125px;margin-right:10px;vertical-align:bottom;">
        <el-option v-for="item in showTypes" :key="item.value" :label="item.label" :value="item.value"></el-option>
      </el-select>
      <span>增加</span>
      <el-input-number v-model="addNum" :controls="false" style="width:50px;" :min="1" :max="50"></el-input-number>
      <span>个{{ category.name }}</span>
      <el-button @click="handleAddTableRow">增加</el-button>
    </el-row>
    <div class="tableBox">
      <div class="center middle_sty" style="flex:2;" v-show="tableData && !tableData.length">
        <p>
          <i class="icon-wushuju iconfont"></i>
          暂无数据
        </p>
      </div>
      <div class="tableLeft" v-show="tableData && tableData.length">
        <handson-table ref="table"></handson-table>
      </div>
    </div>
    <el-row class="center">
      <el-button type="primary" size="medium" @click="handleCreateTableData" class="create_button" :disabled="createDisable">创建资产</el-button>
    </el-row>
    <upload-files-dialog :read="onlyRead ? true : false" ref="upload" @changeFile="fileChange" :keysArr="filesArr"
                         :dialog="myDialog"></upload-files-dialog>
    <upload-img-dialog :read="onlyRead ? true : false" @changeFile="imgChange" :keysArr="imgsArr"
                       :dialog="myDialog"></upload-img-dialog>
    <pic-dialog :read="onlyRead ? true : false" :dialog="myDialog" :keysArr="picsArr" @change="changePics"></pic-dialog>
    <details-dialog :iframeSrc="iframeSrc" v-if="myDialog.details" :dialog="myDialog"></details-dialog>
  </div>
</template>
<script>
import tools from "@/utils/scan/tools"
import handsonUtils from "@/utils/hasontableUtils"
import showTools from "@/utils/handsontable/notShow"
import text from "@/utils/handsontable/mainText"
import session from "@/framework/utils/storage"
import buildFloor from '@/utils/handsontable/buildFloorData'

import handsonTable from "@/components/common/handsontable"
import { createPropertyData } from "@/api/scan/request"
import { getDataDictionary } from "@/api/dict";

import { mapGetters, mapActions } from "vuex"

import uploadFilesDialog from "@/components/dialogs/list/filesDialog"
import uploadImgDialog from "@/components/dialogs/list/uploadImgDialog"
import picDialog from "@/components/dialogs/list/picDialog"

export default {
  components: {
    uploadFilesDialog,
    uploadImgDialog,
    picDialog,
    handsonTable
  },
  data() {
    return {
      addNum: 1,
      onlyRead: false,
      showTypes: [
        { value: "Visible", label: '只看采集信息' },
        { value: "all", label: '全部' }
      ],
      buildFloorData: [],
      tableHeader: [],
      tableData: session.get("propertyAddData")
        ? session.get("propertyAddData").length
          ? session.get("propertyAddData")
          : [{}]
        : [{}],
      copyTableData: [],
      category: "", //当前设备类
      myDialog: {
        uploadFiles: false, //上传文件
        uploadImgs: false, //上传单个图片
        pic: false, //多个图片
        addDevice: false,
        systemType: false,
        details: false, //详情页
        lookPic: false //图片查看
      },
      inputMap: {
        flowBuild: {
          editable: true,
          code: "flowBuild",
          name: "建筑楼层",
          path: "flowBuild",
          category: 'STATIC',
          dataType: "ENUM"
        }
      }, //信息点和输入方式映射表
      qrcodeUrl: "", //二维码图片地址
      filesArr: [], //保存临时的文件key
      imgsArr: [], //临时保存的图片key数组
      picsArr: [], //临时设备图片keys数组
      systemId: null,
      graphyId: null,
      id: 0,
      showType: this.$route.query.showType,
      EquipmentList: [],
      createDisable: false
    };
  },
  computed: {
    ...mapGetters("layout", ["projectId", "secret", "userId"])
  },
  created() {
    this.category = this.$route.query;
    buildFloor.getData(this.buildFloorData)
    this.getTableHeader();
  },
  methods: {
    // 获取表头数据(初始化表格)
    async getTableHeader() {
      let params = {
        orders: "sort asc, name desc",
        pageNumber: 1,
        pageSize: 1000,
        type: this.category.Family
      };
      await getDataDictionary(params, res => {
        this.tableHeader = res.content;
        this.tableHeader.forEach(item => {
            if (item.path) {
              this.inputMap[item.path] = item;
            }
        })
        this.initTable();
      });
    },
    // 创建资产数据
    async handleCreateTableData() {
      let params = {}
      let newData = this.tableData.filter(item => {
        let keys = Object.keys(item)
        keys.map(key => {
          //将值为空字符串的属性删除
          if (item[key] == "") {
            delete item[key];
          }
        });
        let newK = Object.keys(item)
        if (keys.length && newK.length) {
          return item;
        }
      })
      if (!newData.length) {
        this.$message("创建信息为空,请录入信息后再创建!");
        return;
      }
      let flag = false;
      newData.map(item => {
        item.family = this.category.Family
        if (!item.localName) {
          flag = true
        }
        // 处理建筑-楼层
        if (item.flowBuild) {
          let BuildingId = item.flowBuild.split("-")[0]
          let FloorId = item.flowBuild.split("-")[1]
          if (BuildingId && FloorId) {
            item.buildingId = BuildingId
            item.gloorId = FloorId
          } else if (BuildingId && !FloorId) {
            item.buildingId = BuildingId
          }
        }
      })
      // 添加资产
      if (flag) {
        this.$message.info("存在设备的本地名称为空，请检查")
        return;
      }
      params.content = newData
      this.createDisable = true;
      await createPropertyData(params, res => {
        this.createDisable = false;
        this.$message.success("添加成功!")
        session.remove("propertyAddData")
        this.$router.push({
          name: "propertyLedger",
          params: { Family: this.category.Family }
        })
      })
    },
    // 删除表格行
    handleDeleteTableRow(a,b,c,d) {
        if (d && d === 'ContextMenu.removeRow') {
            this.$message.success("删除成功");
            this.formaTableData();
        }
    },
    // 添加行
    handleAddTableRow() {
      let addRowLength = this.addNum
      for (let i = 0; i < addRowLength; i++) {
        this.tableData.push({})
      }
      this.initTable()
      this.formaTableData()
    },
    //修改
    handleUpdataTable(changeData, source) {
      if (!this.onlyRead && source != 'ObserveChanges.change') {
        this.formaTableData()
      }
    },
    //保存去掉空字段的新增数据
    formaTableData() {
      let newData = this.tableData.filter(item => {
        let keys = Object.keys(item)
        keys.map(key => {
          //将值为空字符串的属性删除
          if (item[key] == "") {
            delete item[key]
          }
        })
        if (keys.length && Object.keys(item).length) {
          return item;
        }
      })
      session.set("propertyAddData", newData);
    },
    //格式化表头显示的数据
    formatHeaderData(list) {
      let arr = tools.copyArr(list)
      let data = showTools.headerTextFilter(arr, 'property', this.onlyRead, this.showType, true)
      data.unshift("所属建筑楼层")
      return data
    },
    //格式化表头头映射的数据
    formatHeaderType(list) {
      let arr = tools.copyArr(list)
      let data = showTools.headerTypeFilter(arr, 'property', this.onlyRead, this.showType, true)
      data.unshift({
        data: "flowBuild",
        renderer: tools.customDropdownRenderer,
        editor: "chosen",
        chosenOptions: {
          data: this.buildFloorData
        }
      })
      return data
    },
    initTable() {
      //实例化表格
      let settings = {
        data: this.tableData,
        colHeaders: this.formatHeaderData(this.tableHeader),
        columns: this.formatHeaderType(this.tableHeader),
        rowHeights: 30,
        fillHandle: 'vertical', //允许纵向填充
        maxRows: this.tableData.length,
        contextMenu: this.onlyRead ? false : {
          items: {
            remove_row: {
              name: "删除资产"
            }
          }
        },
        // 事件
        afterChange: this.handleUpdataTable, //修改后
        afterFilter: this.trimmedRows, //排序前
        afterRemoveRow: this.handleDeleteTableRow, //右键删除
        afterOnCellMouseDown: this.handleTdClick //鼠标点击
      };
      this.$nextTick(() => {
        this.tableExample = this.$refs.table.init(settings);
      });
    },
    //去除数组中相同的元素
    array_diff(a, b) {
      for (var i = 0; i < b.length; i++) {
        for (var j = 0; j < a.length; j++) {
          if (a[j] == b[i]) {
            a.splice(j, 1);
            j = j - 1;
          }
        }
      }
      return a;
    },
    //上传文件弹窗触发事件
    fileChange(keys) {
      this.setDataToMain(keys, this.messKey, this.row);
    },
    //上传图片弹窗触发事件
    imgChange(keys) {
      this.setDataToMain(keys, this.messKey, this.row);
    },
    //设备图片弹窗改变事件
    changePics(keys) {
      this.setDataToMain(keys, this.messKey, this.row);
    },
    //表格点击事件
    handleTdClick(el, rowArr) {
      //点击的是表头
      if (rowArr.row < 0) {
        return;
      }
      //被筛选过后的数组
      let trimmedArr = this.trimmedRows();
      //是否启用了排序
      let isSort = this.tableExample.getPlugin("columnSorting").isSorted();
      if (trimmedArr.length && isSort) {
        let sortArr = this.myHotArr.getPlugin("columnSorting").rowsMapper
          .__arrayMap;
        let infos = this.tableData[trimmedArr[sortArr[rowArr.row]]];
        this.getInfors(infos, { row: sortArr[rowArr.row], col: rowArr.col });
      } else if (isSort) {
        //排序后的数组
        let sortArr = this.tableExample.getPlugin("columnSorting").rowsMapper
          .__arrayMap;
        let infos = this.tableData[sortArr[rowArr.row]];
        this.getInfors(infos, { row: sortArr[rowArr.row], col: rowArr.col });
      } else if (trimmedArr.length) {
        let infos = this.tableData[trimmedArr[rowArr.row]];
        this.getInfors(infos, { row: trimmedArr[rowArr.row], col: rowArr.col });
      } else {
        let infos = this.tableData[rowArr.row];
        this.getInfors(infos, rowArr);
      }
    },
    //获取被筛选掉的行号
    trimmedRows() {
      var plugin = this.tableExample.getPlugin("trimRows").trimmedRows;
      let dataLength = this.tableData.length;
      let dataArr = new Array();
      for (let i = 0; i < dataLength; i++) {
        dataArr.push(i);
      }
      if (plugin.length <= 0) {
        dataArr = undefined;
      } else {
        dataArr = this.array_diff(dataArr, plugin);
      }
      return dataArr || [];
    },
    getInfors(infos, row) {
      let val = this.tableExample.colToProp(row.col);
      let inputData = this.inputMap[val];
      this.row = row.row;
      this.messKey = val;
      switch (val) {
        //保险文件--设备文档--安装质检报告
        case 'infos.insuranceFile': //保险文件
        case 'infos.archive': //设备文档
        case 'infos.checkReport': //安装质检报告
        case 'infos.maintainManual': //维修保养手册
        case 'infos.approachingAcceptance': //进场验收单
        case 'infos.acceptanceReport': //验收报告
        case 'infos.operationManual': //操作说明书
        case 'infos.originalCertificate': //原厂证明
        case 'infos.testReport': //检测报告
        case 'infos.productCertification': //产品合格证
        case 'infos.installInstruction': //安装说明书
        case 'infos.supplierContract': //供应合同
        case 'infos.drawing': //设备图纸
        case 'infos.installDrawing': //安装图纸
          let IPSdata = tools.dataForKey(this.tableData[row.row], val);
          this.filesArr = IPSdata ? IPSdata : [];
          this.myDialog.uploadFiles = true;
          break;
        //安装照片--设备铭牌照片
        case 'infos.installPic':
        case 'infos.nameplate':
          let SSPPdata = tools.dataForKey(this.tableData[row.row], val);
          this.imgsArr = SSPPdata ? SSPPdata : [];
          this.myDialog.uploadImgs = true;
          break;
        //设备照片
        case 'infos.pic':
          let Pdata = tools.dataForKey(this.tableData[row.row], val);
          this.picsArr = Pdata ? Pdata : [];
          this.myDialog.pic = true;
          break;
        default:
          break;
      }
      if (!this.onlyRead && !inputData.editable) {
        this.$confirm('该信息点的值为自动生成，不可人工维护！', '提示', {
            confirmButtonText: '我知道了',
            showCancelButton: false,
            type: 'warning',
            center: true
        }).then(() => {
            return false;
        });
      }
    },
    utilToKey(key, name, data, messName) {
      if (key == name) {
        this.setDataToMain(data[key], messName, this.row);
      }
    },
    //判断是否有值，有值赋值
    setDataToMain(data, key, row) {
      if (!!data && data != "--") {
        if (!!this.tableData[row]) {
          //铭牌照片特殊处理
          tools.setDataForKey(this.tableData[row], key, data)
          // this.tableData[row][key] = data;
        } else {
          this.tableData[row] = {};
          tools.setDataForKey(this.tableData[row], key, data)
        }
      } else {
        tools.setDataForKey(this.tableData[row], key, "")
      }
    }
  }
};
</script>
<style lang="less" scoped>
#deviceList {
  overflow: hidden;
  height: 100%;
  background-color: #fff;
  padding: 10px;
  position: relative;

  .right {
    background: #fff;
  }

  .search-header {
    overflow: hidden;
    padding: 0 10px 10px 10px;
    border-bottom: 1px solid #bcbcbc;
  }

  .tableBox {
    display: flex;
    height: calc(100% - 100px);
    margin-top: 10px;

    .tableLeft {
      flex: 1;
    }
  }

  .create_button {
    margin-top: 10px;
  }
}
</style>
